package com.example.workflow;

import jakarta.inject.Named;
import javax.inject.Inject;
import org.camunda.bpm.engine.delegate.DelegateExecution;
import org.camunda.bpm.engine.delegate.JavaDelegate;
import javax.mail.*;
import javax.mail.internet.*;
import java.util.Properties;

@Named
public class UpdateEndUserService implements JavaDelegate {

    @Override
    public void execute(DelegateExecution execution) throws Exception {
        // 1. Retrieve username (assuming it holds the recipient email)
        String recipientEmail = (String) execution.getVariable("EmailAddress");

        // 2. Construct notification message (assuming ticket ID is already set)
        String updateMessage = "Your ticket has been submitted. We will update you on the progress.";

        // 3. Send notification email
        sendNotificationEmail(recipientEmail, updateMessage, "Ticket Submitted");
    }

    private void sendNotificationEmail(String recipientEmail, String messageBody, String subject) {
        // Email configuration
        String host = "imap.gmail.com"; // Change to your SMTP server
        String username = "user.ticketing.systemg2@gmail.com"; // Change to your email address
        String password = "xpzjeayahydrjiib"; // Change to your email password

        Properties props = new Properties();
        props.put("mail.smtp.auth", "true");
        props.put("mail.smtp.starttls.enable", "true");
        props.put("mail.smtp.host", host);
        props.put("mail.smtp.port", "587"); // Change port if necessary

        // Create session with authentication
        Session session = Session.getInstance(props, new Authenticator() {
            @Override
            protected PasswordAuthentication getPasswordAuthentication() {
                return new PasswordAuthentication(username, password);
            }
        });

        try {
            // Create MimeMessage object
            Message message = new MimeMessage(session);

            // Set From: header field
            message.setFrom(new InternetAddress(username));

            // Set To: header field
            message.setRecipients(Message.RecipientType.TO, InternetAddress.parse(recipientEmail));

            // Set Subject: header field
            message.setSubject(subject);

            // Set message body
            message.setText(messageBody);

            // Send email
            Transport.send(message);

            System.out.println("Update email sent successfully to " + recipientEmail);
        } catch (MessagingException e) {
            throw new RuntimeException(e);
        }
    }
}